<?php

class cashbill extends base
{
    public $code;
    public $title;
    public $description;
    public $enabled;
    
    function cashbill()
    {
            global $order;
            $this->code = 'cashbill';
            $this->codeVersion = '1.3.2';
            $this->title = MODULE_PAYMENT_CASHBILL_TEXT_TITLE;
            $this->description = MODULE_PAYMENT_CASHBILL_TEXT_DESCRIPTION;
      	    $this->sort_order = MODULE_PAYMENT_CASHBILL_SORT_ORDER;
      	    $this->enabled = ((MODULE_PAYMENT_CASHBILL_STATUS == 'True') ? true : false);

      	if ((int)MODULE_PAYMENT_CASHBILL_ORDER_STATUS_ID > 0)
        	$this->order_status = MODULE_PAYMENT_CASHBILL_ORDER_STATUS_ID;
      	
      	
            if (is_object($order))
                $this->update_status();
    }
    
    function install()
    {
        global $db;
        $db->Execute("Insert into " . TABLE_CONFIGURATION . "
		( configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added )
		values (
			'Identyfikator Punktu Platnosci :',
			'MODULE_PAYMENT_CASHBILL_CUSTOMER',
			'',
			'Identyfikator klienta CashBill, otrzymany w procesie rejestracji punktu platnosci w systemie CashBill S.A.',
			'6',
			'1',
			now()
		);");
         $db->Execute("Insert into " . TABLE_CONFIGURATION . "
	    ( configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added )
	    values (
	    	'Klucz Punktu Platnosci:',
	    	'MODULE_PAYMENT_CASHBILL_SECRET_PHRASE',
	    	'',
	    	'Tajny klucz sklepu, otrzymany w procesie rejestracji punktu platnosci w systemie CashBill S.A.',
	    	'6',
	    	'2',
	    	now()
	    );");
        $db->Execute("Insert into ".TABLE_CONFIGURATION."
		( configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added )
		values (
			'Status:',
			'MODULE_PAYMENT_CASHBILL_STATUS',
			'False',
			'Okresla czy dana metoda platnosci bedzie doszenna dla klientow sklepu',
			'6',
			'3',
			'zen_cfg_select_option(array(\'True\', \'False\'), ',
			now()
		);");
        $db->Execute("Insert into " . TABLE_CONFIGURATION . "
		( configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added )
		values (
			'Kolejnosc wyswietlania metody platnosci:',
			'MODULE_PAYMENT_CASHBILL_SORT_ORDER',
			'0',
			'Kolejnosc wyswietlania metody platnosci. Metody platnosci wyswietlane sa na podstawie tej wartosci w kolejnosci od najmniejszej do najwiekszej.',
			'6',
			'4',
			now()
		)");
        $db->Execute("Insert into " . TABLE_CONFIGURATION . "
		( configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added )
		values (
			'Status zamowienia, dla transakcji oczekujacej:',
			'MODULE_PAYMENT_CASHBILL_ORDER_STATUS_ID',
			'0',
			'Zamowienia oplacane ta metoda platnosci, w przypadku zainicjowanych, niezrealizowanych, badz nieukonczonych transakcji, otrzymaja ten status<br />(\'Oczekujacy\' - status zalecany)',
			'6',
			'5',
			'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name',
			now()
		)");
        
        $db->Execute("Insert into " . TABLE_CONFIGURATION . "
		( configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added )
		values (
			'Status zamowienia, dla transakcji oplaconej:',
			'MODULE_PAYMENT_CASHBILL_SUCCESS_ORDER_STATUS_ID',
			'0',
			'Zamowienia oplacone ta metoda platnosci, w przypadku pozytywnie autoryzowanych transakcji, otrzymaja ten status<br />(\'Oplacone\' - status zalecany)',
			'6',
			'5',
			'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name',
			now()
		)");
        
        $db->Execute("Insert into " . TABLE_CONFIGURATION . "
		( configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added )
		values (
			'Status zamowienia, dla transakcji nieoplaconej:',
			'MODULE_PAYMENT_CASHBILL_NEGATIVE_ORDER_STATUS_ID',
			'0',
			'Zamowienia oplacane ta metoda platnosci, w przypadku negatywnie autoryzowanych transakcji, otrzymaja ten status<br />(\'Nieoplacone\' - status zalecany)',
			'6',
			'5',
			'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name',
			now()
		)");
        
    }
    
    function remove()
    {    
        global $db;
        $db->Execute("DELETE FROM " . TABLE_CONFIGURATION . " WHERE configuration_key IN ('" . implode("', '", $this->keys()) . "')");
    }
    
    function keys()
    {
        return array(
            'MODULE_PAYMENT_CASHBILL_CUSTOMER',
            'MODULE_PAYMENT_CASHBILL_SECRET_PHRASE',
            'MODULE_PAYMENT_CASHBILL_STATUS',
            'MODULE_PAYMENT_CASHBILL_SORT_ORDER',
            'MODULE_PAYMENT_CASHBILL_ORDER_STATUS_ID',
            'MODULE_PAYMENT_CASHBILL_SUCCESS_ORDER_STATUS_ID',
            'MODULE_PAYMENT_CASHBILL_NEGATIVE_ORDER_STATUS_ID');
    }
  
    function check()
    {
		global $db;
		if (!isset($this->_check))
		{
			$check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_CASHBILL_STATUS'");
			$this->_check = $check_query->RecordCount();
		}
		return $this->_check;
    }
    
    function javascript_validation()
    {
        return false;
    }
    
    function selection()
    {
        return array(
            'id' => $this->code,
            'module' => $this->title,
            'icon' => MODULE_PAYMENT_CASHBILL_ICON
        );
    }
    function pre_confirmation_check()
    {
        return false;
    }
    function confirmation() {
       return array('title' => MODULE_PAYMENT_CASHBILL_TEXT_TITLE);
    }
    function process_button()
    {
        return false;
    }
    
    function before_process()
    {
        return false;
    }
    
    function after_process()
    {
    		global $insert_id, $db, $order;
		
    		echo "<html><head></head><body  onload=\"document.cashbillpayment.submit();\">";
    		echo "<form name=\"cashbillpayment\" method=\"post\" action=\"https://pay.cashbill.pl/form/pay.php\">";
    		
    		
			$amount = number_format( $order->info['total']*$order->info['currency_value'], 2 );
			$amountC = $order->info['currency'];
			$lang = 'PL';
			$cashbill_id = $_SESSION['order_number_created'];


			$id = MODULE_PAYMENT_CASHBILL_CUSTOMER;
			$desc = 'Zamowienie nr: '.$insert_id;
			$userdata = $insert_id;
	
			$sign = md5 ( $id.'|'.$amount.'|'.$amountC.'|'.$desc.'|'.$lang.'|'.$userdata.'|'.'ZenCart'.'|'.
			$order->billing['firstname'].'|'.
			$order->billing['lastname'].'|'.
			$order->customer['email_address'].'|'.
			$order->customer['telephone'].'|'.
			$order->billing['street_address'].'|'.
			$order->billing['suburb'].'||'.
			$order->billing['city'].'|'.
			$order->billing['postcode'].'|'.
			$order->billing['country']['title'].'|'.
			MODULE_PAYMENT_CASHBILL_SECRET_PHRASE );

			$button =
			zen_draw_hidden_field('service', $id ) .
			zen_draw_hidden_field('amount', $amount ) .
			zen_draw_hidden_field('currency', $amount ) .
			zen_draw_hidden_field('lang', $lang ) .
			zen_draw_hidden_field('desc', $desc ) .
			zen_draw_hidden_field('userdata', $userdata ) .
			zen_draw_hidden_field('ref', 'ZenCart' ) .
			zen_draw_hidden_field('forname', $order->billing['firstname'] ) .
			zen_draw_hidden_field('surname', $order->billing['lastname'] ) .
			zen_draw_hidden_field('email', $order->customer['email_address'] ) .
			zen_draw_hidden_field('street', $order->billing['street_address'] ) .
			zen_draw_hidden_field('street_n1', $order->billing['suburb'] ) .
			zen_draw_hidden_field('city', $order->billing['city'] ) .
			zen_draw_hidden_field('postcode', $order->billing['postcode'] ) .
			zen_draw_hidden_field('country', $order->billing['country']['title'] ) .
			zen_draw_hidden_field('tel', $order->customer['telephone'] ) .
			zen_draw_hidden_field('sign', $sign );

			echo $button;
			echo "</form><p>Przekierowanie...</p>";

			
			$db->Execute("UPDATE `orders` SET `orders_status` = '".MODULE_PAYMENT_CASHBILL_ORDER_STATUS_ID."' WHERE `orders_id` = " .$insert_id.";");
		$db->Execute("INSERT INTO `orders_status_history`
					SET `orders_id` = '".$insert_id ."',
						`orders_status_id` = '".MODULE_PAYMENT_CASHBILL_ORDER_STATUS_ID."',
						`date_added` = '".date("Y-m-d H:i:s")."',
						`customer_notified` = '0',
						`comments` = 'Kupujacy zostal przekierowany na strone CashBill dla Transakcji ID: ".$insert_id."';");
		$_SESSION['cart']->reset(false);
		
			exit();
    }
    
    
    function get_error()
    {
        return false;
    }
    
    function update_status()
    {
    
    }
    
}